<?php

if (Channel::Exists($INFO['DEST'])){
	$Chan=new Channel($INFO['DEST']);
}

if ($_Bot->getCfg('blackjack_serve')==false){
	Wise_msg($Chan->getName(), 'Blackjack has been temporarily disabled.');
	exit;
}

$Player=null;
$Dealer=null;

//Fetch the dealer object if it exists.  If it doesn't, make a new one.
function loadDealerData($Chan){
	$res=db_query("SELECT Data FROM mod_blackjack_dealer WHERE Channel='".addslashes($Chan)."'");
	if (!$res || db_num_rows($res)==0){
		//echo db_sql_error();
		$Dealer=new BJDealer($Chan);
		//Wise_msg($chan, 'Couldn\'t load dealer data for '.$chan);
		if (!saveDealerData($Chan, serialize($Dealer), 'insert')){
			Wise_msg($Chan, 'Unable to save game data.');
			exit;
		}
	}
	else {
		$Dealer=db_result($res, 0, 0);
		$Dealer=unserialize($Dealer);
	}
	return $Dealer;
}


//Load the player data
function loadPlayerData($nick, $chan){
	$res=db_query(	"SELECT Data FROM mod_blackjack_players WHERE Nick='".addslashes($nick)."' AND ".
			"Channel='".addslashes($chan)."'");
	if (!$res || db_num_rows($res)==0){
		//Wise_msg($chan, 'Couldn\'t load player data for '.$nick.' in '.$chan);
		$Player=new BJPlayer($nick);
		if (!savePlayerData($Player, $chan, 'insert')){
			Wise_msg($chan, 'Unable to save player data.');
			exit;
		}
	}
	else {
		$Player=db_result($res, 0, 0);
		$Player=unserialize($Player);
	}
	return $Player;
}


function savePlayerData($Player, $Chan, $type='update'){
	//Save the player info to the database
	$Data=addslashes(serialize($Player));
	$Money=$Player->getMoney();
	$Nick=addslashes($Player->getNick());
	$Chan=addslashes($Chan);
	if ($type=='update'){
		$res=db_query(	"UPDATE mod_blackjack_players SET Data='".$Data.
				"', Money='".$Money."' WHERE Channel='".$Chan."' AND Nick='".$Nick."'");
	}
	else {
		$res=db_query(	"INSERT INTO mod_blackjack_players(Nick, Channel, Money, Data) VALUES ('".
				$Nick."', '".$Chan."', '".$Money."', '".$Data."')");
	}
	if (!$res){
		//echo db_sql_error();
		return false;
	}
	return true;
}

function saveDealerData($Chan, $Data, $type='update'){
	//Save the dealer to the database
	if ($type=='update'){
		$res=db_query(	"UPDATE mod_blackjack_dealer SET Data='".addslashes($Data).
				"' WHERE Channel='".addslashes($Chan)."'");
	}
	else {
		$res=db_query(	"INSERT INTO mod_blackjack_dealer(Channel, Data) VALUES('".
				addslashes($Chan)."', '".addslashes($Data)."')");
		
	}
	//echo db_sql_error();
	if (!$res){
		return false;
	}
	return true;
}

function logDonation($From, $To, $Amount){
	$From=addslashes($From);
	$To=addslashes($To);
	$Amount=addslashes($Amount);
	$res=db_query("INSERT INTO mod_blackjack_donations(Nick, Amount, NickTo) VALUES ('{$From}', '{$Amount}', '{$To}')");
	if (!$res || db_affected_rows()==0){
		return false;
	}
	return true;
}

function getHandTotal($Cards){
	$CTotal=count($Cards);
	$total=0;
	$acecount11=0;
	$acecount1=0;
	for ($i=0; $i<$CTotal; $i++){
		$card=$Cards[$i];
		switch ($card{1}){
			case 'A':
				$acecount11+=11;
				$acecount1+=1;
				break;
			case 'J':
			case 'Q':
			case 'K':
				$total+=10;
				break;
			default:
				$total+=intval($card{1});
				break;
		}
	}
	if ($total >= 21){ //It's greater than 21, and that's not counting any ace's
		return $total+$acecount1; //Return it, using any ace's as 1's
	}
	if ($total+$acecount11 > 21){
		$removed=0;
		while ($acecount11-(11*$removed) < 11){
			$removed++;
			if ($total+($acecount11-(11*$removed)+$removed) <= 21){
				break;
			}
		}
		$total+=$acecount11-(11*$removed)+$removed;
	}
	else {
		$total+=$acecount11;
	}
	return $total;
}

function set_timeout($User, $Chan, $clear){
	$timeout=90; //In Seconds;
	if ($clear){
		Wise_timer_remove(':Wiser!bot@timer PRIVMSG '.$Chan->getName().' :!bj timeout '.$User->getNick(), time()+$timeout);
	}
	else {
		Wise_timer(':Wiser!bot@timer PRIVMSG '.$Chan->getName().' :!bj timeout '.$User->getNick(), time()+$timeout);
	}
}

?>
