<?php
set_time_limit(60*60); //60 minute time out, since this could take a while

//Let the dir to the php manual be specified on the command line, or default to a dir.
$base_dir=empty($argv[1])?"/home/php/":$argv[1];

//Where the results of this will be placed.
$output_file="./PHP_Manual.txt";

if ($base_dir{strlen($base_dir)-1} == '/' || $base_dir{strlen($base_dir)-1} == '\\'){
	$base_dir=substr($base_dir, 0, -1);
}


function timeFormat($dif){
	$Aday=(60*60*24);
	$Ahour=(60*60);
	$Amin=60;
	$Ayear=$Aday*365;

	$years=(int)($dif/$Ayear);
	if ($years >= 1){
		$dif-=$Ayear*$years;
		$years.=($years==1)?" year":" years";
		$years.=" ";
	}
	else {
		$years='';
	}
	$days=(int)($dif/$Aday);
	if ($days >= 1){
		$dif-=$Aday*$days;
		$days.=($days==1)?" day":" days";
		$days.=" ";
	}
	else {
		$days='';
	}
	$hours=(int)($dif/$Ahour);
	if ($hours >= 1){
		$dif-=$Ahour*$hours;
		$hours.=($hours==1)?" hour":" hours";
		$hours.=" ";
	}
	else {
		$hours='';
	}
	$mins=(int)($dif/$Amin);
	if ($mins>=1){
		$dif-=$Amin*$mins;
		$mins.=($mins==1)?" minute":" minutes";
		$mins.=" ";
	}
	else {
		$mins='';
	}
	$seconds=($dif==1)?"$dif second":"$dif seconds";
	$uptime="$years$days$hours$mins$seconds";
	return $uptime;
}

$d=opendir($base_dir);


$fd=fopen($output_file,"w");
$time_start=time();
$count=0;

$Exceptions=array("function.return.html"=>1,
						"function.include.html"=>1,
						"function.require.html"=>1,
						"function.require-once.html"=>1,
						"function.include-once.html"=>1,
);

while ($file=readdir($d)){
	if ($file == '.' || $file == '..' || substr($file, 0, 9) != 'function.' || isset($Exceptions[$file])){
		continue;
	}

//	$con=implode('',file($base_dir.'/'.$file));
	$con_p=fopen($base_dir.'/'.$file, 'r');
	if (filesize($base_dir.'/'.$file) > 10240){ //If file is greater than 10k, only read 10k
		$con=fread($con_p, 10240);
	}
	else { //Else, read it all
		$con=fread($con_p, filesize($base_dir.'/'.$file));
	}
	fclose($con_p);
	
	//Remove new lines

	$con=str_replace("\r",' ', $con);
	$con=str_replace("\n",' ', $con);
	$con=str_replace('  ',' ', $con);

	$con=strip_tags($con,'<div>');
	$con=strtr($con, array_flip(get_html_translation_table(HTML_ENTITIES)));
	$con=substr($con, strpos($con, 'refnamediv')+13);

	//Fix the &# symbols
	$con=str_replace('&#62;','>',$con);
	$con=str_replace('&#13;','',$con);
	$con=str_replace('&#60;','<',$con);
	$con=str_replace('&#38;','&',$con);

	$con=trim($con);

	//replace non-breaking spaces w/ normal ones
	$con=str_replace(chr(160),' ',$con);

	//Get some of the data
	//ereg("^(.[^)]+.)([a-zA-Z0-9_]+) -- (.[^<]+)</DIV",$con,$matches);




	$version=substr($con, 0, strpos($con, ')')+1);
	$con=trim(substr($con, strpos($con, ')')+1));

//	fputs($fd, "$con\n");
//	fflush($fd);
//	if ($count == 20){
//		fclose($fd);
//		exit;
//	}


	$name=substr($con, 0, strpos($con, ' '));
	$con=trim(substr($con, strpos($con, ' ')));


	$description=substr($con, 0, strpos($con, '</DIV'));
	//Remove double spaces by making them single spaces
	while($description != ($description=str_replace('  ',' ',$description))) ;
	

	$con=trim(strip_tags(substr($con, strpos($con, '</DIV')+7)));


	$version=str_replace('( ','(',$version);
	$version=str_replace(' )',')',$version);


	$con=substr($con, strpos($con, 'Description')+11);
	$con=trim($con);

	//Get Return value
	$returnval=substr($con, 0, strpos($con, ' '));
	$con=trim(substr($con, strpos($con, ' ')));
	if ($returnval==$name){
		$returnval='[none]';
	}
	
	//Get name
	$con=trim(substr($con, strpos($con, ' ')));

	$params=substr($con, 0, strpos($con, ')')+1);
	$params=str_replace('( ','(',$params);
	$params=str_replace(' )',')',$params);

//	$fd=fopen($output_file, "a");
	fputs($fd, "$file\t\t$returnval\t\t$name\t\t$params\t\t$version\t\t$description\n");
//	fflush($fd);
//	fclose($fd);
	echo "Done with $file...\n";
	flush();

	unset($params);
	unset($con);
	unset($name);
	unset($file);
	unset($version);
	unset($description);
	unset($returnval);

	$count++;
}

fclose($fd);
$time_end=time();

echo "Total compiliation time: ".timeFormat($time_end-$time_start);
echo "\nTotal files: $count";
?>